






#import "Mouth.h"
#import "MouseAdvancedSubmittedTailSocial.h"

@interface Mouth() {
    NSMutableSet *_launchedRuleRetainSeedDestroy;
}

@end

@implementation Mouth



+ (instancetype)sliceBikeInstance {
    static id sliceBikeInstance = nil;

    static dispatch_once_t restToken;
    dispatch_once(&restToken, ^{
        sliceBikeInstance = [[self alloc] init];
    });

    return sliceBikeInstance;
}


- (NSMutableSet *)launchedRuleRetainSeedDestroy {
    if (!_launchedRuleRetainSeedDestroy) {
        _launchedRuleRetainSeedDestroy = [[NSMutableSet alloc] init];
    }
    return _launchedRuleRetainSeedDestroy;
}




+ (BOOL)cousinFailDismissDissolveUnsafe:(MouseAdvancedSubmittedTailSocial *)zb_destination {
    return [self.sliceBikeInstance cousinFailDismissDissolveUnsafe:zb_destination];
}

- (BOOL)cousinFailDismissDissolveUnsafe:(MouseAdvancedSubmittedTailSocial *)zb_destination {
    if ([self.launchedRuleRetainSeedDestroy containsObject:zb_destination]) {
        return NO;
    }
    [self.launchedRuleRetainSeedDestroy addObject:zb_destination];
    return YES;
}


+ (BOOL)silenceBoyfriendCandidateExternRareHas:(MouseAdvancedSubmittedTailSocial *)zb_destination {
    return [self.sliceBikeInstance silenceBoyfriendCandidateExternRareHas:zb_destination];
}

- (BOOL)silenceBoyfriendCandidateExternRareHas:(MouseAdvancedSubmittedTailSocial *)zb_destination {
    if (![self.launchedRuleRetainSeedDestroy containsObject:zb_destination]) {
        return NO;
    }
    [self.launchedRuleRetainSeedDestroy removeObject:zb_destination];
    return YES;
}


+ (void)itsRelationsSmileStepPowerChannels {
    [self.sliceBikeInstance itsRelationsSmileStepPowerChannels];
}

- (void)itsRelationsSmileStepPowerChannels {
    [self.launchedRuleRetainSeedDestroy removeAllObjects];
}


+ (NSInteger)barBeforeInsertArgumentReadApply {
    return [self.sliceBikeInstance barBeforeInsertArgumentReadApply];
}

- (NSUInteger)barBeforeInsertArgumentReadApply {
    return self.launchedRuleRetainSeedDestroy.count;
}


+ (NSString *)scopePushName {
    if (NSThread.isMainThread) {
        return @"";
    }else {
        NSString *label = [NSString stringWithCString:dispatch_queue_get_label(DISPATCH_CURRENT_QUEUE_LABEL) encoding:NSUTF8StringEncoding];
        return label ?: NSThread.currentThread.name;
    }
}


+ (void)screenOne:(FocusLevel)zb_level
          dashWho:(const char *)dashWho
      earFitShear:(const char *)earFitShear
          picture:(NSUInteger)picture
       arrivalTen:(id)arrivalTen
        keyShrink:(NSString *)keyShrink, ... {
    va_list args;
    
    if (keyShrink) {
        va_start(args, keyShrink);
        
        NSString *shakeBrief = [[NSString alloc] initWithFormat:keyShrink arguments:args];
        
        va_end(args);
        
        va_start(args, keyShrink);
        
        [self.sliceBikeInstance brushStationRemoveCoachedConjugate:zb_level
                                   shakeBrief:shakeBrief
                                    issueFlow:[self scopePushName]
                                      dashWho:[NSString stringWithFormat:@"%s", dashWho]
                                  earFitShear:[NSString stringWithFormat:@"%s", earFitShear]
                                      picture:picture
                                   arrivalTen:arrivalTen];
        
        va_end(args);
    }
}


- (void)brushStationRemoveCoachedConjugate:(FocusLevel)zb_level
              shakeBrief:(NSString *)shakeBrief
               issueFlow:(NSString *)issueFlow
                 dashWho:(NSString *)dashWho
             earFitShear:(NSString *)earFitShear
                 picture:(NSUInteger)picture
              arrivalTen:(id)arrivalTen {
    
    for (MouseAdvancedSubmittedTailSocial *headset in self.launchedRuleRetainSeedDestroy) {
        
        NSString *whileRankedMessage;
        
        if (!headset.auditCan) continue;
        
        whileRankedMessage = whileRankedMessage == nil ? shakeBrief : whileRankedMessage;
        
        if ([headset learnExecutionIllMaximumMultiplySmoothed:zb_level skipped:dashWho earFitShear:earFitShear shakeBrief:shakeBrief]) {
            
            NSString *energyEnd = whileRankedMessage == nil ? shakeBrief :whileRankedMessage;
            
            NSString *food = [self dragSpeechStep:earFitShear];
            
            if (headset.catalogCityNoticeBarriersAir) {
                dispatch_async(headset.auditCan, ^{
                    [headset tapDone:zb_level pubOld:energyEnd issueFlow:issueFlow dashWho:dashWho earFitShear:food picture:picture
                          arrivalTen:arrivalTen];
                });
            }else {
                dispatch_sync(headset.auditCan, ^{
                    [headset tapDone:zb_level pubOld:energyEnd issueFlow:issueFlow dashWho:dashWho earFitShear:food picture:picture
                          arrivalTen:arrivalTen];
                });
            }
        }
    }
}

- (NSString *)dragSpeechStep:(NSString *)earFitShear {
    NSString *food = earFitShear;
    NSRange foggyNow = [food rangeOfString:@"("];
    
    if (foggyNow.location != NSNotFound) {
        food = [food substringToIndex:foggyNow.location];
    }
    food = [food stringByAppendingString:@"()"];
    return food;
}

@end
